﻿/**
どらっぐあんどどろっぷ
*/
module etc.negui.event.dropfile;

debug(dropfile) import std.stdio: wl = writefln;
debug(dropfile) void main() {}

import win32.windows;
import std.contracts;

//import nemuxi.base;
import etc.negui.system.base;

///
class DropFileException: NeGuiException {
	mixin MixInNeGuiException;
}

/**
*/
class DropFile: HandleRaii, IRaii {
	protected alias Handle hDrop;
	mixin MixInHandleRaiiNotDuplicate;
	mixin MixInHandleRaiiNotDup;

	override protected void Kill() {
		if(hDrop) {
			DragFinish(hDrop);
			hDrop = hDrop.init;
		}
	}

	protected {
		///
		Text[] Addresses;
		///
		POINT  Point;
	}
	///
	immutable bool inClient;
	
	/**
	History:
		$(HIST_VER 1.031,
			$(HIST_B 取得座標勘違いしてた。)
		)
	*/
	this(HDROP hDrop, bool Suicide) {
		super(hDrop, Suicide);

		//enforce(DragQueryPoint(hDrop, &Point), new DropFileException(Text("座標取得失敗")));
		inClient = cast(bool)DragQueryPoint(hDrop, &Point);

		Addresses = new Text[DragQueryFile(hDrop, -1, null, 0)];
		assert(Addresses.length);
		
		foreach(i, ref Address; Addresses) {
			auto FileAddress = new wchar[DragQueryFile(hDrop, i, null, 0) + 1];
			assert(FileAddress.length);
			enforce(FileAddress.length-1 == DragQueryFile(hDrop, i, FileAddress.ptr, FileAddress.length), new DropFileException(Text("D&Dファイル取得失敗")));
			Address = Text(FileAddress[0..$-1]);
		}
	}

	/**
	*/
	const ref const(POINT) point() {
		return Point;
	}

	///
	const size_t length() {
		return Addresses.length;
	}
	///
	const const(Text) opIndex(size_t Index) {
		return Addresses[Index];
	}
	///
	const const(Text)[] opSlice() {
		return Addresses[];
	}
	///
	const const(Text)[] opSlice(size_t Start, size_t End) {
		return cast(Text[])Addresses[Start..End];
	}
}

