﻿/**

*/
module etc.negui.window.mainwindow;

debug import std.stdio: wl = writefln;
debug(mainwindow) void main() {}

import win32.windows;

public import etc.negui.system.base;
public import etc.negui.negui;
public import etc.negui.window.window;
public import etc.negui.window.newindow;
import etc.negui.input.keyboard.accelerator;
import etc.negui.window.dialog.dialog;
public import etc.negui.event.events;

/**
History:
	$(HIST_VER 1.00β18,
		$(HIST_S Oneの扱いを微妙に変更。)
	)
*/
class MainWindow: NeWindow {
	invariant() {
		debug assert(One == 1);
	}
	debug static int One=0;

	/**
	History:
		$(HIST_VER 1.022,
			$(HIST_NEW)
		)
	*/
	this(ref NEGUIINFO NeGuiInfo) {
		debug One += 1;
		super(NeGuiInfo);
	}
	/**
	*/
	this() {
		NEGUIINFO NeGuiInfo;
		this(NeGuiInfo);
	}
	
	private mixin Message;
	/**
	*/
	INT execute() {
		return loop();
	}

	/**
	*/
	protected override void OnDestroy() {
		super.OnDestroy();
		PostQuitMessage(0);
	}

	private {
		struct WINDOWCLOSURE {
			Window[] windows;
			MainWindow me;
			DWORD ProccessID;
		}
		static extern(Windows) BOOL EnumWindowsProc(HWND hWnd , LPARAM lParam) {
			auto WindowClosure=cast(WINDOWCLOSURE*)lParam;
			
			DWORD ProccessID;
			GetWindowThreadProcessId(hWnd, &ProccessID);
			if(WindowClosure.ProccessID != ProccessID) {
				return TRUE;
			} else if((new OtherWindow(hWnd)).className != WindowClosure.me.className) {
				return TRUE;
			}
			if(auto window=cast(Window)NeGui.getGuiObject(hWnd)) {
				if(window == WindowClosure.me) {
					return TRUE;
				}
				WindowClosure.windows ~= window;
			}
			
			return TRUE;
		}
	}
	/**
	History:
		$(HIST_VER 1.00β18,
			$(HIST_NEW)
		)
	*/
	public final class MyChildren {
		Window[] windows;
		this(Window[] windows) {
			this.windows = windows;
		}
		~this() {
			delete windows;
			delete values;
		}
		enum MODE {
			ENABLE
		}
		private {
			bool[] values;
			MODE Mode;
		}
		void lock(MODE Mode) {
			this.Mode = Mode;
			final switch(Mode) {
				case MODE.ENABLE:
					values = new bool[windows.length];
					for(auto i=0; i < windows.length; i++) {
						values[i] = windows[i].enable;
						windows[i].enable =false;;
					}
					break;
			}
		}
		void release() {
			final switch(Mode) {
				case MODE.ENABLE:
					for(auto i=0; i < windows.length; i++) {
						if(windows[i].isAlive) {
							windows[i].enable = values[i];
						}
					}
					break;
			}
		}
	}
	/**
	History:
		$(HIST_VER 1.00β18,
			$(HIST_S 戻り値の型変更。)
		)
		$(HIST_VER 1.00β17,
			$(HIST_NEW)
		)
	*/
	final MyChildren getNeGuiWindow() {
		WINDOWCLOSURE WindowClosure;
		WindowClosure.me = this;
		GetWindowThreadProcessId(hWnd, &WindowClosure.ProccessID);
		EnumWindows(&EnumWindowsProc, cast(LPARAM)&WindowClosure);

		return new MyChildren(WindowClosure.windows);
	}
}


